import os, shutil

#You will need to have debugging tools for windows installed
#Also this path may differ on your machine
symchk = "\"C:\\Program Files\\Debugging Tools for Windows (x86)\\symchk.exe\""

#change this as needed
temp_dir = "C:\\Users\chris\\Desktop\\temp_dir"
output_dir = "C:\\Users\\chris\\Desktop\\dbg_pdb_outdir"


#list to hold all the modules for which to retrieve symbols
modules_list = "firefox_modules.txt"

#symbol server
sym_server = "SRV*.*http://msdl.microsoft.com/download/symbols;"
sym_server += "SRV*.*http://symbols.mozilla.org/firefox;"
sym_server += "SRV*.*http://chromium-browser-symsrv.commondatastorage.googleapis.com"


#list to hold the location of all the acquired symbols
symbol_list = "acquired_symbols.txt"

def GetSymbols():
    if os.path.exists(symbol_list):
        f = file(symbol_list, 'w')
        f.write('')
        f.close()
        
    command = symchk + " " + "/r /it " + modules_list + " /s " + sym_server + " /ol " + symbol_list
    os.system(command)

if __name__ == "__main__":

    #acquire the symbols from the list
    GetSymbols()

    #iterate through each item in teh acquired list
    #and copy it to the current directly
    f = file(symbol_list, 'r')
    for line in f.readlines():
        pieces = line.split(',')

        #copy the pdb to the output directory
        pdb_file = pieces[3].strip()
        copy_pdb_file = output_dir + "\\" + os.path.basename(pdb_file)
        shutil.copy(pdb_file, copy_pdb_file)

    #close the file
    f.close()

    #make a copy of the executable into the output directory
    f = file(modules_list, 'r')
    for line in f.readlines():
        exe_file = line.strip()
        copy_exe_file = output_dir + "\\" + os.path.basename(exe_file)
        shutil.copy(exe_file, copy_exe_file)
