#!/usr/bin/env ruby
#
# Google Chrome Stable updates blog scraper
#
# This script simply downloads posts and saves them locally.
#
# Author: Joshua J. Drake / Accuvant LABS
# License: BSD
#

require 'net/http'
require 'uri'

require 'nokogiri'


#
# Scrape all posts from the Google Chrome blog
#
ret = []

opts = {}
page = 0
uri = URI.parse('http://googlechromereleases.blogspot.com/search/label/Stable%20updates')
#puts uri.inspect

loop {
	$stderr.puts "*** Requesting: #{uri}"

	req = Net::HTTP::Get.new(uri.request_uri, opts)
	res = Net::HTTP.start(uri.host, uri.port) { |http|
		http.request(req)
	}
	#puts res.inspect
	#puts res.body.inspect

	fname = "Stable_updates_pg#{page}.html"
	$stderr.puts "*** Saving contents to #{fname}"
	File.open(fname, "wb") { |fd|
		fd.write res.body
	}

	doc = Nokogiri::HTML(res.body)
	#puts doc.inspect

	# Look for "older posts" link
	older = nil
	doc.xpath('//a[@title = "Older Posts"]').each { |node|
		older = node
		break
	}
	# No more older posts?
	break if not older

	# Use this uri next
	opts['Referrer'] = uri.to_s
	uri = URI.parse(older['href'])

	page += 1
}
