#!/bin/sh

DIR=/home/jdrake/browserz/browsers
cd $DIR

# reset the database
rake db:drop db:create db:migrate

function load_firefox {
  # load firefox data
  cd $DIR/public/data/firefox/mfsa
  echo "[*] Loading Firefox MFSA data..."
  ./scraper.rb > out 2> err
  cat err
  echo ""
  
  echo "[*] Loading Firefox Bugzilla data..."
  cd ../bugzilla
  ./bug_scraper.rb > out 2> err
  cat err
  echo ""
}


function load_ie {
  # load IE data
  cd $DIR/public/data/ie/bulletins
  echo "[*] Loading IE MS security bulletin data..."
  #cd $DIR/public/data/ie/index
  #echo "[*] Loading IE MSB index data..."
  ./scraper.rb > out 2> err
  cat err
  echo ""

  echo "[*] Loading manually recorded Microsoft reported dates.."
  ./update_dates.sh
  echo ""
}


function load_chrome {
  # load Chrome data
  cd $DIR/public/data/chrome
  echo "[*] Loading Chrome security blog data..."
  ./scraper.rb > out 2> err
  cat err
  echo ""

  echo "[*] Loading chrome bug data from chromium-issues.csv.."
  ./update_from_csv.rb
  echo ""
}

load_chrome
load_firefox
load_ie
