/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is 
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or 
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#define _WINSOCKAPI_
#include <windows.h>
#include <windowsx.h>

#include "plugin.h"

#include <ws2tcpip.h>
#include <tchar.h>
#include <stdio.h>

#include "exports.h"



//  ErrorMessage support function.
//  Retrieves the system error message for the GetLastError() code.
//  Note: caller must use LocalFree() on the returned LPCTSTR buffer.
LPCTSTR ErrorMessage(DWORD error) 
{ 
    LPVOID lpMsgBuf;

    FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER 
                   | FORMAT_MESSAGE_FROM_SYSTEM 
                   | FORMAT_MESSAGE_IGNORE_INSERTS,
                  NULL,
                  error,
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPWSTR) &lpMsgBuf,
                  0,
                  NULL);

    return( (LPCTSTR) lpMsgBuf);
}

//  PrintError support function.
//  Simple wrapper function for error output.
/*
DWORD PrintError(char * errDesc)
{
	DWORD errID = GetLastError();
    LPCTSTR errMsg = ErrorMessage(errID);
	fprintf(f, "%s:\n\t** ERROR [0x%08X]**  %s\n", errDesc, errID, errMsg);
//	_tprintf(TEXT("%s:\n\t** ERROR [0x%08X]**  %s\n"), errDesc, errID, errMsg);
    LocalFree((LPVOID)errMsg);

	return errID;
}

void PrintReg(char *good){
	fprintf(f, "%s", good);
	fflush(f);
}
*/

/*
void PrintErrorByCode(char * errDesc, DWORD SysErrCode)
{
	LPCTSTR errMsg = ErrorMessage(SysErrCode);
    _tprintf(TEXT("%s:\n\t** ERROR [0x%08X]**  %s\n"), errDesc,SysErrCode, errMsg);
    LocalFree((LPVOID)errMsg);
}
*/



void charlie(){
	FILE *f = fopen("C:\\Users\\Charlie\\Desktop\\foo.txt", "w+");
//	HANDLE h = (HANDLE) _fileno(f);
	RunIt(f);
	fclose(f);
}


void old_charlie()
{
/*
	//multi-use
	WCHAR buff[1024];

	FILE *f = fopen("C:\\Users\\Charlie\\Desktop\\foo.txt", "w+");

	//Test 1,2 
	WCHAR wszSystemDirFile[MAX_PATH] = L"C:\\Windows\\System32\\ntdll.dll";
	WCHAR wszSystemDirFile_Write[MAX_PATH] = L"C:\\Windows\\System32\\fake.dll";
	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwBytesWritten = 0;

	//Test 1: Read system directory file
	hFile = CreateFileW(wszSystemDirFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);  
	if (hFile == INVALID_HANDLE_VALUE)
	{
		PrintError("[!] System Directory File Read Failed");
	}
	else
	{
		PrintReg("[*] Open System Directory Read PASSED!\n");
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	//Test 2: Write system directory file
	hFile = CreateFileW(wszSystemDirFile_Write, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		PrintError("[!] System Directory File Write Failed");
	}
	else 
	{
		memset(buff, 0x0, sizeof(buff));
		wcsncpy_s(buff, sizeof(buff) / 2, L"DEADBEEF", (sizeof(buff) / 2) - 1);
		WriteFile(hFile, buff, sizeof(buff), &dwBytesWritten, NULL);
		PrintReg("[*] Open System Directory Write PASSED!\n");
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	//Test 3: Create a process (report Integrity level)
	STARTUPINFOW si;
	PROCESS_INFORMATION pi;
	WCHAR wszProcess_Sys[MAX_PATH] = L"C:\\Windows\\System32\\cmd.exe";
	//WCHAR wszProcess_Sys[MAX_PATH] = L"C:\\Users\\chris\\Desktop\\cmd.exe";  //XXX Potentially start a non-systemdir process?
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	ZeroMemory(&pi, sizeof(pi));
	if (!CreateProcessW(NULL, wszProcess_Sys, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
	{
		PrintError("[!] Create Process Failed");
	}
	else
	{
		PrintReg("[*] Create Process PASSED!\n");
		if(!TerminateProcess(pi.hProcess, 0))
		{
			PrintError("!!! Terminate Process Failed!");
			exit(1);
		}
	}

	////Test 4: Create/Read/Write/Listen from a Socket
	WSADATA wsaData;
	struct addrinfo *result = NULL, *ptr = NULL;
	struct addrinfo hints;
	int iResult;
	SOCKET ConnectSocket = INVALID_SOCKET;
	char *sendbuf = "GET / HTTP/1.1\r\nHost: illmatics.com\r\n\r\n";
	char recvbuf[1024];
	BOOL send_passed = false;
	BOOL recv_passed = false;
	BOOL listen_passed = false;
	BOOL proceed = false;

	//Listen socket
	SOCKET ListenSocket = INVALID_SOCKET;
	sockaddr_in service;

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != 0)
	{
		PrintError("WSAStart failed: %d\n");
	}
	else
	{
		proceed = true;
	}

	if(proceed)
	{
		iResult = getaddrinfo("illmatics.com", "80", &hints, &result);
		if (iResult != 0)
		{
			PrintError("getaddrinfo faild: %d\n");
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	//attempt to get the first address returned
	ptr = result;

	if(proceed)
	{
		ConnectSocket = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol);
		if(ConnectSocket == INVALID_SOCKET)
		{
			PrintError("Error at socket(): %ld\n");
			freeaddrinfo(result);
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	if(proceed)
	{
		iResult = connect(ConnectSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
		if(iResult == SOCKET_ERROR) 
		{
			closesocket(ConnectSocket);
			ConnectSocket = INVALID_SOCKET;
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	if(proceed)
	{
		iResult = send(ConnectSocket, sendbuf, (int)strlen(sendbuf), 0);
		if(iResult == SOCKET_ERROR)
		{
			PrintError("send() failure: %d\n");
			proceed = false;	
		}
		else
		{
			proceed = true;
			send_passed = true;
		}
	}

	if(send_passed)
	{
		PrintReg("[*] WSASocket send() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket send() Failed");
	}

	if(proceed)
	{
		ZeroMemory(&recvbuf, sizeof(recvbuf));
		iResult = recv(ConnectSocket, recvbuf, (int)sizeof(recvbuf), 0);
		if (iResult > 0)
		{
			recv_passed = true;
		}
	}

	if(recv_passed)
	{
		PrintReg("[*] WSASocket recv() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket send() Failed");
	}

	//Listen section
	proceed = false;

	ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(ListenSocket == INVALID_SOCKET)
	{
		PrintError("Error at socket(): %ld\n");
		proceed = false;
	}
	else 
	{
		proceed = true;
	}

	service.sin_family = AF_INET;
	service.sin_addr.s_addr = inet_addr("0.0.0.0");
	service.sin_port = htons(31337);

	if(proceed)
	{
		if(bind(ListenSocket, (SOCKADDR*)&service, sizeof(service)) == SOCKET_ERROR)
		{
			PrintError("[!] WSASocket bind() Failed");
			proceed = false;
		}
		else
		{
			PrintReg("[*] WSASocket bind() PASSED!\n");
			proceed = true;
		}
	}

	if(proceed)
	{
		if(listen(ListenSocket, SOMAXCONN) == SOCKET_ERROR)
		{
			listen_passed = false;
		}
		else
		{
			//this should produce a warning in windows 7
			listen_passed = true;
		}
	}

	if(listen_passed)
	{
		PrintReg("[*] WSASocket listen() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket bind() Failed");
	}
	
	closesocket(ListenSocket);
	closesocket(ConnectSocket);
	WSACleanup();

	//Test 5: Read/Write to clipboard
	char *buffer;
	HGLOBAL clipbuffer;
	HANDLE hClipData;
	HWND hwndMain = GetForegroundWindow();
	HANDLE retHandle = NULL;
	if(OpenClipboard(hwndMain))
	{
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, 0x20);
		buffer = (char*)GlobalLock(clipbuffer);
		strcpy(buffer, LPCSTR("Test Clipboard Data"));
		GlobalUnlock(clipbuffer);
		retHandle = SetClipboardData(CF_TEXT, clipbuffer);
		if(retHandle == NULL) 
		{
			PrintError("[!] SetClipboardData Failed");
		}
		else
		{
			PrintReg("[*] SetClipboardData PASSED!\n");
		}
		CloseClipboard();
	}

	retHandle = NULL;
	if(OpenClipboard(hwndMain))
	{
		hClipData = GetClipboardData(CF_TEXT);
		if(hClipData == NULL) 
		{
			PrintError("[!] GetClipboardData Failed");
		}
		else
		{
			PrintReg("[*] GetClipboardData PASSED!\n");
		}
		buffer = (char*)GlobalLock(hClipData);
		//PrintReg("Clipboard Data %s\n", buffer);
		GlobalUnlock(hClipData);
		CloseClipboard();
	}

	//Test 6: Read/Write from the Global Atom Table
	ATOM test_atom = 0;
	test_atom = GlobalAddAtom((LPCSTR) "GlobalAtomTest");
	if(test_atom == 0)
	{
		PrintError("[!] GlobalAddAtom Failed");
	}
	else
	{
		PrintReg("[*] GlobalAddAtom PASSED!\n");
	}

	test_atom = 0;
	test_atom = GlobalFindAtom((LPCSTR) "GlobalAtomTest");
	if(test_atom == 0)
	{
		PrintError("[!] GlobalFindAtom Failed");
	}
	else
	{
		PrintReg("[*] GlobalFindAtom PASSED!\n");
	}

	////Test 7: Create/Switch Desktop
	HDESK new_desktop = NULL;
	new_desktop = CreateDesktop(LPCSTR("ChrisDesktop"), NULL, NULL, 0x0, GENERIC_ALL, NULL);
	if(new_desktop == NULL)
	{
		PrintError("[!] CreateDesktop Failed");
	}
	else
	{
		PrintReg("[*] CreateDesktop PASSED!\n");
	}

	if(SwitchDesktop(new_desktop) == 0)
	{
		PrintError("[!] SwitchDesktop Failed");
	}
	else
	{
		PrintReg("[*] SwitchDesktop PASSED!\n");
	}
	CloseDesktop(new_desktop);

	////Test 8: Read/Write HKLM";
	DWORD BYTEINCREMENT = 4096;
	DWORD CURRSIZE = 1024;
	DWORD dwRet;
	DWORD cbData = CURRSIZE;
	char *key_data = NULL;

	//these will need to be changed based on the current registry values of your machine


	WCHAR *hklm_valuename = L"Chris";
	char *hkcu_valuename = "DAEMON Tools Lite";

	key_data = (char*)malloc(CURRSIZE);
//	dwRet = RegGetValue(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", L"ChrisTest", RRF_RT_ANY, NULL, (PVOID)key_data, &cbData); 

	unsigned long type=REG_SZ, size=1024;
	HKEY key;
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_READ, &key);

	dwRet = RegQueryValueEx( key,
                             "ChrisTest",
                             NULL,
                             &type,
                             (LPBYTE) &key_data[0],
                             &cbData );


	if(dwRet != ERROR_SUCCESS)
	{
		PrintError("[!] RegGetValueW(HKEY_LOCAL_MACHINE) Failed:");
	}
	else
	{
		PrintReg("[*] RegGetValueW(HKEY_LOCAL_MACHINE) PASSED! [%s]\n");
	}

	free(key_data);

	key_data = (char*)malloc(CURRSIZE);
	cbData = CURRSIZE;
//	dwRet = RegGetValue(HKEY_CURRENT_USER, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", L"ChrisTest", RRF_RT_ANY, NULL, (PVOID)key_data, &cbData); 

	type=REG_SZ, size=1024;

	RegOpenKeyEx(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_READ, &key);

	dwRet = RegQueryValueEx( key,
                             "ChrisTest",
                             NULL,
                             &type,
                             (LPBYTE) &key_data[0],
                             &cbData );

	if(dwRet != ERROR_SUCCESS)
	{
		PrintError("[!] RegGetValueW(HKEY_LOCAL_MACHINE) Failed:");
	}
	else
	{
		PrintReg("[*] RegGetValueW(HKEY_LOCAL_MACHINE) PASSED! [%s]\n");
	}

	free(key_data);



	//Test 9: Read/Write SystemParamentersInfo()
	int aMouseInfo[3];
	BOOL fResult;

	fResult = SystemParametersInfo(SPI_GETMOUSE, 0, &aMouseInfo, 0);
	if(fResult == 0)
	{
		PrintError("[!] Get SystemParametersInfo Failed");
		PrintError("[!] Set SystemParametersInfo Failed");
	}
	else
	{
		PrintReg("[*] Get SystemParametersInfo PASSED!\n");

		int old_mouse_speed = aMouseInfo[2];
		aMouseInfo[2] = 2 * old_mouse_speed;
		fResult = SystemParametersInfo(SPI_SETMOUSE, 0, &aMouseInfo, SPIF_SENDCHANGE);
		if(fResult == 0)
		{
			PrintError("[!] Set SystemParametersInfo Failed");
		}
		else
		{
			PrintReg("[*] Set SystemParametersInfo PASSED!\n");
			aMouseInfo[2] = old_mouse_speed;
			SystemParametersInfo(SPI_SETMOUSE, 0, &aMouseInfo, SPIF_SENDCHANGE);

		}
	}

	//Test 10: Windows Message Broadcast
	LPCTSTR strMsg = TEXT("Message to be Sent");
	DWORD err_val;
	SendMessage(HWND_BROADCAST , WM_SETTEXT, 0, (LPARAM)strMsg);

	err_val = GetLastError();

	if(err_val == ERROR_ACCESS_DENIED)
	{
		PrintError("[!] SendMessage Broadcast Failed");
	}
	else
	{
		PrintReg("[*] SendMessage Broadcast PASSED!\n");
	}



	//Test 11: Set Windows Hooks
	typedef int (__stdcall *MYPROC)(HWND a, LPCSTR b, LPCSTR c, INT d); 
	HINSTANCE hinstLib;
	//MYPROC ProcMsg;
	static HHOOK hhookSysMsg;
	HOOKPROC hkprcSysMsg;

	hinstLib = LoadLibrary(TEXT("User32"));
	if(hinstLib != NULL)
	{
		hkprcSysMsg = (HOOKPROC)GetProcAddress(hinstLib, "MessageBoxA");
		if(hkprcSysMsg != NULL)
		{
			hhookSysMsg = SetWindowsHookEx(WH_DEBUG, hkprcSysMsg, hinstLib, 0);
			if(hhookSysMsg != NULL)
			{
				PrintReg("[*] SetWindowsHookEx PASSED!\n");
				UnhookWindowsHookEx(hhookSysMsg);
			}
			else
			{
				PrintError("[!] SetWindowsHookEx Failed");
			}
		}
		else
		{
			PrintError("[!] GetProcessAddress Failed");
		}
		FreeLibrary(hinstLib);
	}
	else
	{
		PrintError("[!] LoadLibrary Failed");
	}
	
	fclose(f);
	*/
	Sleep(10000);
}


//////////////////////////////////////
//
// general initialization and shutdown
//
NPError NS_PluginInitialize()
{
  return NPERR_NO_ERROR;
}

void NS_PluginShutdown()
{
}

/////////////////////////////////////////////////////////////
//
// construction and destruction of our plugin instance object
//
nsPluginInstanceBase * NS_NewPluginInstance(nsPluginCreateData * aCreateDataStruct)
{
  if(!aCreateDataStruct)
    return NULL;

  nsPluginInstance * plugin = new nsPluginInstance(aCreateDataStruct->instance);

  // now is the time to tell Mozilla that we are windowless
  NPN_SetValue(aCreateDataStruct->instance, NPPVpluginWindowBool, NULL);

  return plugin;
}

void NS_DestroyPluginInstance(nsPluginInstanceBase * aPlugin)
{
  if(aPlugin)
    delete (nsPluginInstance *)aPlugin;
}

////////////////////////////////////////
//
// nsPluginInstance class implementation
//
nsPluginInstance::nsPluginInstance(NPP aInstance) : nsPluginInstanceBase(),
  mInstance(aInstance),
  mInitialized(FALSE)
{
}

nsPluginInstance::~nsPluginInstance()
{
}

NPBool nsPluginInstance::init(NPWindow* aWindow)
{
  // no GUI to init in windowless case
  mInitialized = TRUE;
//charlie();
  return TRUE;
}

void nsPluginInstance::shut()
{
  // no GUI to shut in windowless case
  mInitialized = FALSE;
}

NPBool nsPluginInstance::isInitialized()
{
  return mInitialized;
}

NPError nsPluginInstance::SetWindow(NPWindow* aWindow)
{
  // keep window parameters
  mWindow = aWindow;
  return NPERR_NO_ERROR;
}

uint16 nsPluginInstance::HandleEvent(void* aEvent)
{
  NPEvent * event = (NPEvent *)aEvent;
  switch (event->event) {
    case WM_PAINT: 
    {
      if(!mWindow)
        break;

      // get the dirty rectangle to update or repaint the whole window
      RECT * drc = (RECT *)event->lParam;
      if(drc)
        FillRect((HDC)event->wParam, drc, (HBRUSH)(COLOR_ACTIVECAPTION+1));
      else {
        RECT rc;
        rc.bottom = mWindow->y + mWindow->height;
        rc.left   = mWindow->x;
        rc.right  = mWindow->x + mWindow->width;
        rc.top    = mWindow->y;
        FillRect((HDC)event->wParam, &rc, (HBRUSH)(COLOR_ACTIVECAPTION+1));
      }
      break;
    }
    case WM_KEYDOWN:
    {
      Beep(1000,100);
	  charlie();
	  Beep(1000,100);
      break;
    }
    default:
      return 0;
  }
  return 1;
}