#!/bin/bash

date=`/usr/bin/date "+%Y%m%d"`
wget='/usr/bin/wget -nv'
mddir='./malwaredomains'
mpdir='./malwarepatrol'
sort='/usr/bin/sort'

echo "Checking if URL directories exist..."
  if [ -d $mddir ];
      then echo "Yep."
        else
      mkdir $mddir
  fi

  if [ -d $mpdir ];
      then echo "Yep yep."
        else
      mkdir $mpdir
  fi
echo "Done."

echo ""
echo "Getting latest MalwareDomains list..."
  $wget "http://www.malwaredomains.com/updates/?C=M;O=D" -O $mddir/malwaredomains$date.html
  mdlatest=`cat $mddir/malwaredomains$date.html | grep ".txt"| head -1 | sed 's/^.*href="//' | sed 's/">.*//'`

  if [ -a $mddir/$mdlatest ]; then
        echo "Latest already available."
          else
        $wget "http://www.malwaredomains.com/updates/$mdlatest" -O $mddir/$mdlatest
  fi
echo "Done."

echo ""
echo "Getting latest MalwarePatrol list..."
  $wget "http://www.malwarepatrol.net/cgi/submit?action=list" -O $mpdir/malwarepatrol$date.txt
echo "Done."

echo "Prepping the malware URL list:"
  grep -v "#" $mpdir/malwarepatrol$date.txt > /tmp/malwareurlstmp$date.txt
  awk -F " " '{print $1}' $mddir/$mdlatest | sed 's+^+http://+' >> /tmp/malwareurlstmp$date.txt
  awk -F " " '{print $1}' $mddir/$mdlatest | sed 's+^+http://www.+' >> /tmp/malwareurlstmp$date.txt
  $sort -R /tmp/malwareurlstmp$date.txt > malwareurls$date.txt
  urlcount=`wc -l malwareurls$date.txt | awk -F " " '{print $1}'`
  rm /tmp/malwareurlstmp$date.txt

echo ""
echo "Done."
echo "Randomly sorted file saved as malwareurls$date.txt"
echo "Obtained $urlcount malware URLs. Enjoy."

